
Redmine - Defect #6505

PDF export broken with Japanese (Gannt and Issue Tracking)

2010-09-27 05:48 - Leo Hourvitz

Status: Closed Start date: 2010-09-27

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: PDF export Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate Affected version: 1.0.1

Description

When exporting Gannts or Issue Lists to PDF, the Japanese-language text is garbled (the English-language text comes out fine).  A

sample image is attached.

I suspect this will be true of any PDF export, but those are the two exports I've tried this with.

Note that unlike the report regarding Hebrew, this is not true of CSV export for Issue Lists; those come out fine via the UTF-8

encoding.

CentOS 5.3

MySQL 5.0.77 (yes my charset is UTF-8)

ruby 1.8.7

Rails 1.2.6 (I think, I'm using the one that was packaged with redmine 1.0.1)

I'm in Tokyo so this would seem to rule out decent printing from Redmine.  Because CSV export works, there's always that

workaround for Issue Lists.

I've read about the GANTT rewrite, but the fact this is in issue list export as well suggests it's something more generic.  I listed the

two related reports, but I couldn't see anything where this was resolved.

Related issues:

Related to Redmine - Defect #5884: PDF export doesn't work for Hebrew Closed 2010-07-15

Related to Redmine - Feature #4699: Export PDF in Chinese and Japanese langua... Closed 2010-01-31

Related to Redmine - Defect #7794: Internal server error on formatting an iss... Closed 2011-03-06

Related to Redmine - Defect #4787: Gannt to PNG - CJK (Chinese, Japanese and ... Closed 2010-02-10

Is duplicate of Redmine - Defect #61: Broken character encoding in pdf export Closed

History

#1 - 2010-09-27 05:51 - Leo Hourvitz

Hmm, I just I can't add related issues if I'm not a Developer?

Anyway, the two related (but not identical) issues I see are:

#5884 Hebrew language export problem (but he couldn't export CSVs either?)

#4699 Chinese/Japanese export described as a feature? (I didn't understand the report clearly)

#2 - 2010-09-30 21:37 - Igor Velkov

Same for russian: I try to save as pdf an issue with comments, and got pdf with russian garbled text.

#3 - 2010-10-01 01:04 - Toshi MARUYAMA

In Japanese, Issue Tracking works fine.

Please see http://www.redmine.org/boards/2/topics/11734 .

But Gantt is broken at 1.0.2.

#4 - 2010-12-03 19:23 - John Yani

PDF enconding is a known bug of Redmine. See issue #61.

#5 - 2010-12-04 01:38 - Toshi MARUYAMA
#61 is UTF-8 and font problem.

"general_pdf_encoding" at source:/tags/1.0.4/config/locales/ja.yml#L159 is "CP932".

So, PDF for issue list has no problem as long as user uses only Japanese character and user locale is "ja".

But, Gannt is broken at 1.0.2.

This is related with #6348.

#6 - 2011-03-21 04:12 - Jun NAITOH

- File japanese.rb.patch added

- File korean.rb.patch added

- File chinese.rb.patch added

This patch fixed the PDF export broken problem with Japanese/Chinese/Korean.

This is Rfpdf plugin's problem. Rfpdf plugin don't expect to input of UTF-8 character set....

Flow of PDF export broken problem (issue_to_pdf) in Japanese case.

1. lib/redmine/export/pdf.rb                  : pdf.MultiCell (use UTF-8 character set)

2. vendor/plugins/rfpdf/lib/rfpdf/japanese.rb : def MultiCell (expect SJIS character set input)

3. vendor/plugins/rfpdf/lib/rfpdf/japanese.rb : Cell (expect SJIS character set output)

4. lib/redmine/export/pdf.rb                  : def Cell (expect UTF-8 character set input)

MultiCell break UTF-8 3byte character.(Because, SJIS is 2byte character.)

Changed by this patch.

1. lib/redmine/export/pdf.rb                  : pdf.MultiCell (use UTF-8 character set)

2. vendor/plugins/rfpdf/lib/rfpdf/japanese.rb : def MultiCell (expect UTF-8 character set input)

3. vendor/plugins/rfpdf/lib/rfpdf/japanese.rb : Cell (expect UTF-8 character set output)

4. lib/redmine/export/pdf.rb                  : def Cell (expect UTF-8 character set input)

As for Chinese and Korean, it is similar.

My environment is as follows.

CentOS 5.5(x86)

Redmine 1.1.2

ruby 1.8.7

Rubygems 1.3.5

sqlite 3.3.6

#7 - 2011-03-21 04:32 - Toshi MARUYAMA

- Category changed from Issues to PDF export

- Status changed from New to 7

- Assignee set to Toshi MARUYAMA

#8 - 2011-03-21 07:28 - Toshi MARUYAMA

- Assignee deleted (Toshi MARUYAMA)

It seems an effect of note 6 patches is big.

I don't know about PDF, I remove assignee.

#9 - 2011-03-22 22:24 - Jun NAITOH

- File pdf.rb_utf8.patch added

- File gantt.rb_utf8.patch added

- File korean.rb_utf8.patch added

- File japanese.rb_utf8.patch added

- File chinese.rb_utf8.patch added

Sorry, a effect of note 6 patches is big... I'm think so, too.

I want to reduce the patches's effect. so, I rewrote this patch.

This new patch don't change the rpdf plugin interface spec.
This is related to #1170 patch.

Changed by this rewritten patch.

UTF-8 input function added.

lib/redmine/export/pdf.rb : def UTF8MultiCell (expect UTF-8 character set input, and use iconv)

lib/redmine/export/pdf.rb : def UTF8Cell (expect UTF-8 character set input, and use iconv)

some minor fix.

tab character clash problem fix (japanese.rb only)

don't work 'explicit line break' problem fix (korean.rb only)

etc

#10 - 2011-03-23 12:28 - Toshi MARUYAMA

Jun, thank you for your reply.

Are you Japanese? Do you live in USA? Patch timezone is "-0400".

I am Japanese and I live in Japan.

CJK PDF is very difficult.

I want to close this issue with duplicate of #61.

I can see issue watchers of this site.

Many users watch #61.

#11 - 2011-03-23 14:31 - Jun NAITOH

I'm Japanese and live in Japan. Patch timezone is mistake, sorry.

I understand #61 issue, now.... so, it's very long....

I tested with English/Japanese/Chinese/Korean.

Because, I thought that the PDF export broken problem is CJK only.

But, #61 issue isn't CJK only.

OK, I will try to close #6505 and #61.

#12 - 2011-03-27 13:22 - Toshi MARUYAMA

- Status changed from 7 to Closed

- Resolution set to Duplicate

Thank you posting new patch to #61.

Files

JapaneseBecomesGarbage.png 9.93 KB 2010-09-27 Leo Hourvitz

japanese.rb.patch 2.82 KB 2011-03-21 Jun NAITOH

korean.rb.patch 3.29 KB 2011-03-21 Jun NAITOH

chinese.rb.patch 3.14 KB 2011-03-21 Jun NAITOH

pdf.rb_utf8.patch 9.79 KB 2011-03-22 Jun NAITOH

gantt.rb_utf8.patch 5.14 KB 2011-03-22 Jun NAITOH

korean.rb_utf8.patch 1.86 KB 2011-03-22 Jun NAITOH

japanese.rb_utf8.patch 1.05 KB 2011-03-22 Jun NAITOH

chinese.rb_utf8.patch 1.62 KB 2011-03-22 Jun NAITOH
